//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Orchid

extern color labelscolor=Orange;
extern color linescolor=Orange;
extern int linestyle=1;

//---- buffers
double PBuffer[];
double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
double S3Buffer[];
double R3Buffer[];

double P,S1,R1,S2,R2,S3,R3,last_year_high,last_year_low,last_year_close,this_year_open;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,S1Buffer);
   SetIndexBuffer(2,R1Buffer);
   SetIndexBuffer(3,S2Buffer);
   SetIndexBuffer(4,R2Buffer);
   SetIndexBuffer(5,S3Buffer);
   SetIndexBuffer(6,R3Buffer);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("Yearly Pivot");
   ObjectDelete("Yearly Sup1");
   ObjectDelete("Yearly Res1");
   ObjectDelete("Yearly Sup2");
   ObjectDelete("Yearly Res2");
   ObjectDelete("Yearly Sup3");
   ObjectDelete("Yearly Res3");
   ObjectDelete("YPivot");
   ObjectDelete("YS1");
   ObjectDelete("YR1");
   ObjectDelete("YS2");
   ObjectDelete("YR2");
   ObjectDelete("YS3");
   ObjectDelete("YR3");
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;  
   int limit=Bars-counted_bars;
   
   if(Period()>PERIOD_MN1) return(-1);
   if(counted_bars==0)
     {
      
      ObjectCreate("YPivot", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YPivot", OBJPROP_STYLE, linestyle);
      ObjectSet("YPivot", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Pivot",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Pivot","           Yearly Pivot",10,"Arial",labelscolor);
      
      ObjectCreate("YS1", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YS1", OBJPROP_STYLE, linestyle);
      ObjectSet("YS1", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Sup1",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Sup1","        Yearly Sup1",10,"Arial",labelscolor);
      
      ObjectCreate("YR1", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YR1", OBJPROP_STYLE, linestyle);
      ObjectSet("YR1", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Res1",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Res1","        Yearly Res1",10,"Arial",labelscolor);
      
      ObjectCreate("YS2", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YS2", OBJPROP_STYLE, linestyle);
      ObjectSet("YS2", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Sup2",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Sup2","        Yearly Sup2",10,"Arial",labelscolor);
      
      ObjectCreate("YR2", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YR2", OBJPROP_STYLE, linestyle);
      ObjectSet("YR2", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Res2",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Res2","        Yearly Res2",10,"Arial",labelscolor);
      
      ObjectCreate("YS3", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YS3", OBJPROP_STYLE, linestyle);
      ObjectSet("YS3", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Sup3",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Sup3","        Yearly Sup3",10,"Arial",labelscolor);
      
      ObjectCreate("YR3", OBJ_HLINE, 0, 0, 0);
      ObjectSet("YR3", OBJPROP_STYLE, linestyle);
      ObjectSet("YR3", OBJPROP_COLOR, linescolor);
      ObjectCreate("Yearly Res3",OBJ_TEXT,0,0,0);
      ObjectSetText("Yearly Res3","        Yearly Res3",10,"Arial",labelscolor);
     }
   for(i=limit-1; i>=0; i--)
      {
       // 1sts Days of Year
	    if(TimeDayOfYear(Time[i])<=10 && TimeDayOfYear(Time[i+1])>=355)
	      {
		    last_year_close=Close[i+1];
		    this_year_open=Open[i];		
		    P=(last_year_high+last_year_low+last_year_close+this_year_open)/4;
          R1=(2*P)-last_year_low;
          S1=(2*P)-last_year_high;
          R2=P+(last_year_high-last_year_low);
          S2=P-(last_year_high-last_year_low);
          R3=(2*P)+(last_year_high-(2*last_year_low));
          S3=(2*P)-((2*last_year_high)-last_year_low); 
        	 ObjectMove("YPivot",0,Time[i],P);
        	 ObjectMove("Yearly Pivot",0,Time[i],P);
        	 ObjectMove("YS1",0,Time[i],S1);       	 
          ObjectMove("Yearly Sup1",0,Time[i],S1);
          ObjectMove("YR1",0,Time[i],R1);
          ObjectMove("Yearly Res1",0,Time[i],R1);
          ObjectMove("YS2",0,Time[i],S2);
          ObjectMove("Yearly Sup2",0,Time[i],S2);
          ObjectMove("YR2",0,Time[i],R2);
          ObjectMove("Yearly Res2",0,Time[i],R2);
          ObjectMove("YS3",0,Time[i],S3);
          ObjectMove("Yearly Sup3",0,Time[i],S3);
          ObjectMove("YR3",0,Time[i],R3);
          ObjectMove("Yearly Res3",0,Time[i],R3);
          last_year_low=Low[i];
          last_year_high=High[i];
         }       
       last_year_low=MathMin(last_year_low,Low[i]);   
       last_year_high=MathMax(last_year_high,High[i]);
       PBuffer[i]=P;
       S1Buffer[i]=S1;
       R1Buffer[i]=R1;
       S2Buffer[i]=S2;
       R2Buffer[i]=R2;
       S3Buffer[i]=S3;
       R3Buffer[i]=R3;
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+